# -----------------------------------------------------------------------------
# xtablelist_public.tcl ---
# -----------------------------------------------------------------------------
# (c) 2016, Johann Oberdorfer - Engineering Support | CAD | Software
#     johann.oberdorfer [at] gmail.com
#     www.johann-oberdorfer.eu
# -----------------------------------------------------------------------------
# This source file is distributed under the BSD license.
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#   See the BSD License for more details.
# -----------------------------------------------------------------------------
# Purpose:
#  A TclOO class template to extend tablelist functionality.
# -----------------------------------------------------------------------------


# -----------------------------------------------------------------------------
# Public interface
# -----------------------------------------------------------------------------


oo::define XTableListClass {

	method info {} { puts [self class] }

	method selectArrowCallback {} {

		# this function is called every time an up-down arrow is selected
		# by default, it's empty, but can be predefined to suit the needs
		# in the caller application

		set dummy 0
	}
	
	# unused
	method deleteAllItems {} {
		my variable tblwidget
		my variable widgetCompounds
	
		$tblwidget delete 0 end
		my UpdateStatusInfo {}
	
		# "Undo" button also needs to be disabled
		if { [winfo exists widgetCompounds(b4)] } {
			$widgetCompounds(b4) configure -state disabled
		}
	}


	method addValues {lst {mode ""}} {
		my variable tblwidget
		my variable widgetCompounds
		
		if {![info exists widgetCompounds(undoList)]} {
			set widgetCompounds(undoList) {}
		}
		
		# re-initialize variable (if necessary)
		if {$mode == ""} {
			$tblwidget delete 0 end
			set widgetCompounds(undoList) {}
		}
		
		# populate columns with information ...
		# -------------------------------------
		set cnt 0
		foreach sublist $lst {
			$tblwidget insert end $sublist
			lappend widgetCompounds(undoList) $sublist
			incr cnt
		}
		
		# update status text
		my UpdateStatusInfo $lst
	}

}
